// Code generated by Wire. DO NOT EDIT.

//go:generate go run github.com/google/wire/cmd/wire
//+build !wireinject

package service

import (
	"github.com/livekit/livekit-server/pkg/config"
	"github.com/livekit/livekit-server/pkg/routing"
	"github.com/livekit/protocol/utils"
)

// Injectors from wire.go:

func InitializeServer(conf *config.Config, currentNode routing.LocalNode) (*LivekitServer, error) {
	client, err := createRedisClient(conf)
	if err != nil {
		return nil, err
	}
	roomStore := createStore(client)
	router := createRouter(client, currentNode)
	nodeSelector := CreateNodeSelector(conf)
	keyProvider, err := CreateKeyProvider(conf)
	if err != nil {
		return nil, err
	}
	notifier, err := CreateWebhookNotifier(conf, keyProvider)
	if err != nil {
		return nil, err
	}
	localRoomManager, err := NewLocalRoomManager(roomStore, router, currentNode, nodeSelector, notifier, conf)
	if err != nil {
		return nil, err
	}
	roomService, err := NewRoomService(localRoomManager, router)
	if err != nil {
		return nil, err
	}
	messageBus := utils.NewRedisMessageBus(client)
	recordingService := NewRecordingService(messageBus)
	rtcService := NewRTCService(conf, localRoomManager, router, currentNode)
	server, err := NewTurnServer(conf, roomStore, currentNode)
	if err != nil {
		return nil, err
	}
	livekitServer, err := NewLivekitServer(conf, roomService, recordingService, rtcService, keyProvider, router, localRoomManager, server, currentNode)
	if err != nil {
		return nil, err
	}
	return livekitServer, nil
}

func InitializeRouter(conf *config.Config, currentNode routing.LocalNode) (routing.Router, error) {
	client, err := createRedisClient(conf)
	if err != nil {
		return nil, err
	}
	router := createRouter(client, currentNode)
	return router, nil
}
